from sc_client.constants.sc_type import bitmasks as b
from sc_client.constants.sc_type.sc_type import ScType

UNKNOWN = ScType()

# sc-elements
NODE = ScType(b.SC_TYPE_NODE)
CONNECTOR = ScType(b.SC_TYPE_CONNECTOR)
COMMON_EDGE = ScType(b.SC_TYPE_COMMON_EDGE)
ARC = ScType(b.SC_TYPE_ARC)
COMMON_ARC = ScType(b.SC_TYPE_COMMON_ARC)
MEMBERSHIP_ARC = ScType(b.SC_TYPE_MEMBERSHIP_ARC)

# constancy
CONST = ScType(b.SC_TYPE_CONST)
VAR = ScType(b.SC_TYPE_VAR)

CONST_NODE = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE)
VAR_NODE = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE)
CONST_CONNECTOR = ScType(b.SC_TYPE_CONST | b.SC_TYPE_CONNECTOR)
VAR_CONNECTOR = ScType(b.SC_TYPE_VAR | b.SC_TYPE_CONNECTOR)
CONST_COMMON_EDGE = ScType(b.SC_TYPE_CONST | b.SC_TYPE_COMMON_EDGE)
VAR_COMMON_EDGE = ScType(b.SC_TYPE_VAR | b.SC_TYPE_COMMON_EDGE)
CONST_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_ARC)
VAR_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_ARC)
CONST_COMMON_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_COMMON_ARC)
VAR_COMMON_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_COMMON_ARC)
CONST_MEMBERSHIP_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_MEMBERSHIP_ARC)
VAR_MEMBERSHIP_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_MEMBERSHIP_ARC)

# permanency
PERM_ARC = ScType(b.SC_TYPE_PERM_ARC)
TEMP_ARC = ScType(b.SC_TYPE_TEMP_ARC)

CONST_PERM_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_PERM_ARC)
VAR_PERM_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_PERM_ARC)
CONST_TEMP_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_TEMP_ARC)
VAR_TEMP_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_TEMP_ARC)

# actuality
ACTUAL_TEMP_ARC = ScType(b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC)
INACTUAL_TEMP_ARC = ScType(b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC)

CONST_ACTUAL_TEMP_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC)
VAR_ACTUAL_TEMP_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC)
CONST_INACTUAL_TEMP_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC)
VAR_INACTUAL_TEMP_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC)

# positivity
POS_ARC = ScType(b.SC_TYPE_POS_ARC)
NEG_ARC = ScType(b.SC_TYPE_NEG_ARC)

# positive sc-arcs
CONST_POS_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_POS_ARC)
VAR_POS_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_POS_ARC)

PERM_POS_ARC = ScType(b.SC_TYPE_PERM_ARC | b.SC_TYPE_POS_ARC)
TEMP_POS_ARC = ScType(b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)
ACTUAL_TEMP_POS_ARC = ScType(b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)
INACTUAL_TEMP_POS_ARC = ScType(b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)

CONST_PERM_POS_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_PERM_ARC | b.SC_TYPE_POS_ARC)
CONST_TEMP_POS_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)
CONST_ACTUAL_TEMP_POS_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)
CONST_INACTUAL_TEMP_POS_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)

VAR_PERM_POS_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_PERM_ARC | b.SC_TYPE_POS_ARC)
VAR_TEMP_POS_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)
VAR_ACTUAL_TEMP_POS_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)
VAR_INACTUAL_TEMP_POS_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_POS_ARC)

# negative sc-arcs
CONST_NEG_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NEG_ARC)
VAR_NEG_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NEG_ARC)

PERM_NEG_ARC = ScType(b.SC_TYPE_PERM_ARC | b.SC_TYPE_NEG_ARC)
TEMP_NEG_ARC = ScType(b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)
ACTUAL_TEMP_NEG_ARC = ScType(b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)
INACTUAL_TEMP_NEG_ARC = ScType(b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)

CONST_PERM_NEG_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_PERM_ARC | b.SC_TYPE_NEG_ARC)
CONST_TEMP_NEG_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)
CONST_ACTUAL_TEMP_NEG_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)
CONST_INACTUAL_TEMP_NEG_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)

VAR_PERM_NEG_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_PERM_ARC | b.SC_TYPE_NEG_ARC)
VAR_TEMP_NEG_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)
VAR_ACTUAL_TEMP_NEG_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_ACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)
VAR_INACTUAL_TEMP_NEG_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_INACTUAL_ARC | b.SC_TYPE_TEMP_ARC | b.SC_TYPE_NEG_ARC)

# fuzzy sc-arcs
FUZ_ARC = ScType(b.SC_TYPE_FUZ_ARC)

CONST_FUZ_ARC = ScType(b.SC_TYPE_CONST | b.SC_TYPE_FUZ_ARC)
VAR_FUZ_ARC = ScType(b.SC_TYPE_VAR | b.SC_TYPE_FUZ_ARC)

# semantic sc-node types
NODE_LINK = ScType(b.SC_TYPE_NODE_LINK)
NODE_LINK_CLASS = ScType(b.SC_TYPE_NODE_LINK | b.SC_TYPE_NODE_CLASS)
NODE_TUPLE = ScType(b.SC_TYPE_NODE_TUPLE)
NODE_STRUCTURE = ScType(b.SC_TYPE_NODE_STRUCTURE)
NODE_ROLE = ScType(b.SC_TYPE_NODE_ROLE)
NODE_NON_ROLE = ScType(b.SC_TYPE_NODE_NON_ROLE)
NODE_CLASS = ScType(b.SC_TYPE_NODE_CLASS)
NODE_SUPERCLASS = ScType(b.SC_TYPE_NODE_SUPERCLASS)
NODE_MATERIAL = ScType(b.SC_TYPE_NODE_MATERIAL)

CONST_NODE_LINK = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_LINK)
CONST_NODE_LINK_CLASS = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_LINK | b.SC_TYPE_NODE_CLASS)
CONST_NODE_TUPLE = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_TUPLE)
CONST_NODE_STRUCTURE = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_STRUCTURE)
CONST_NODE_ROLE = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_ROLE)
CONST_NODE_NON_ROLE = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_NON_ROLE)
CONST_NODE_CLASS = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_CLASS)
CONST_NODE_SUPERCLASS = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_SUPERCLASS)
CONST_NODE_MATERIAL = ScType(b.SC_TYPE_CONST | b.SC_TYPE_NODE_MATERIAL)

VAR_NODE_LINK = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_LINK)
VAR_NODE_LINK_CLASS = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_LINK | b.SC_TYPE_NODE_CLASS)
VAR_NODE_TUPLE = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_TUPLE)
VAR_NODE_STRUCTURE = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_STRUCTURE)
VAR_NODE_ROLE = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_ROLE)
VAR_NODE_NON_ROLE = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_NON_ROLE)
VAR_NODE_CLASS = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_CLASS)
VAR_NODE_SUPERCLASS = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_SUPERCLASS)
VAR_NODE_MATERIAL = ScType(b.SC_TYPE_VAR | b.SC_TYPE_NODE_MATERIAL)
